/*
 * MyDevice.cpp
 *
 *  Created on: 10.11.2010
 *      Author: Sergey Fedorenko
 */

#include <QDebug>
#include "MyDevice.h"
#include <string.h>

#ifndef Q_OS_WIN
	#include <sys/time.h>
#endif

MyDevice::MyDevice() {

	m_SendDataTimer=0;

}

MyDevice::~MyDevice() {
	// TODO Auto-generated destructor stub
}

void MyDevice::NewData(unsigned char * data , int len)
{
	QString out;
	for( int i=0; i<len; i++) {
		QString frmt=QString("%1");
		out+=frmt.arg(int(data[i]),2,16,QChar('0'));
	}
	qDebug()<<"Received data: "<<len<<":"<<out;

//	qDebug()<<QString((char*)data);
    return;
}

bool MyDevice::MakeData(unsigned char* data, int* len)
{
    char send_data[]="ATE0I1\r";


    if((GetTick()-m_SendDataTimer)<5000) {
    	return false; // 5 сек ничего не делаем
    }

    m_SendDataTimer=GetTick();

    strcpy((char*)data,send_data);
    (*len)=sizeof(send_data);



    QString out;
	for( unsigned int i=0; i<sizeof(send_data); i++) {
		QString frmt=QString("%1");
		out+=frmt.arg(int(data[i]),2,16,QChar('0'));
	}
	qDebug()<<"Sent data: "<<int(*len)<<":"<<out;

//	qDebug()<<QString((char*)data);

    return true;
}

unsigned long MyDevice::GetTick() {

#ifdef Q_OS_WIN
	return GetTickCount();
#else
    struct timeval tv;
    gettimeofday(&tv,0);
    return (tv.tv_sec*1000+tv.tv_usec/1000);
#endif
}


