/*
 * comportlin.h
 *
 *  Created on: 01.11.2010
 *      Author: Sergey Fedorenko
 */
#ifndef COMPORTLIN_H
#define COMPORTLIN_H

#include <QThread>
#include "ioport.h"
#include <sys/signal.h>

#define COMPORTLIN_READBUFLEN  1024
#define COMPORTLIN_WRITEBUFLEN 1024

class ComPort : public IOPort {

	Q_OBJECT

public:
	/*
	 * Классы потоков для внутреннего использования
	 */
	class CReadThreadLin : public QThread {

	private:
		ComPort* m_ptrComPort;
		volatile bool m_get_new_data_flag;

		void run();

	public :
		CReadThreadLin(){}
		void SetPPort(ComPort* parentComPort) {m_ptrComPort=parentComPort;}
		void SentNewData() { m_get_new_data_flag=true; }
	};

	class CWriteThreadLin : public QThread {

	private:
		ComPort*  m_ptrComPort;  //тот порт, с которым работаем

		void run();

	public :
		CWriteThreadLin() {}
		void SetPPort(ComPort* parentComPort) {m_ptrComPort=parentComPort;}
	};




// Основной класс


private:
    int  				m_idComDevice; // дескриптор файла - ком порта
    bool 				m_fConnected;  // флаг подключения
    CReadThreadLin 		m_trRead;      // поток чтения
    CWriteThreadLin 	m_trWrite;     // поток записи

    bool SetupConnection();//установка настроек подключения
    bool CheckConnection();//Проверка подключения

public:
    ComPort(Device* ptrdevice, QString settings);
    ~ComPort();

    bool OpenPort();
    bool ClosePort();

public slots:
	void slotSentNewData() { if(m_fConnected) m_trRead.SentNewData(); }

};

// класс для создания извещений о приходе новых данных из COM порта по SIGIO
class ComPortLinNotifier : public QObject {

		Q_OBJECT

public:
	ComPortLinNotifier();

	void NotifyHandler() {emit signalNotify();}

signals:
	void signalNotify();
};


extern ComPortLinNotifier theComPortNotifier;
extern void signal_handler_IO(int numsignal);

#endif // COMPORTLIN_H
