#ifndef COMPORT_H
#define COMPORT_H

#include <QThread>
#include "ioport.h"
#include <windows.h>

#define COMPORTWIN_READBUFLEN  1024
#define COMPORTWIN_WRITEBUFLEN 1024


#define ASCII_XON       0x11
#define ASCII_XOFF      0x13

class CReadThread : public QThread
{
public :
    //---Данные----------------------------------------------
    //---Методы----------------------------------------------
    CReadThread(HANDLE,Device *,OVERLAPPED);
private:
    //---Данные----------------------------------------------
    Device * ParentDev;//родитель девайс
    HANDLE idComDevice;//хендл устройства
    OVERLAPPED osRead;
    //---Методы----------------------------------------------
    void ClearComErrors(QString);
    void run();
};

class CWriteThread : public QThread
{
public :
    //---Данные----------------------------------------------
    //---Методы----------------------------------------------
    CWriteThread(HANDLE,Device *,OVERLAPPED);
private:
    //---Данные----------------------------------------------
    Device * ParentDev;//родитель девайс
    HANDLE idComDevice;//хендл устройства
    OVERLAPPED osWrite;
    //---Методы----------------------------------------------
    void ClearComErrors(QString);
    void run();
};

class ComPort : public IOPort
{
private:
    //---Данные----------------------------------------------
    HANDLE idComDevice;//хендл ком порта
    bool fConnected;// флаг подключения
    CReadThread* tRead;//хендл потока чтения
    CWriteThread* tWrite;//хендл потока записи
    OVERLAPPED	osWrite, osRead;//структуры дла асинхронной работы
    //---Методы----------------------------------------------
    bool SetupConnection();//установка настроек подключения
    bool CheckConnection();//Проверка подключения
    void ClearComErrors(QString);
public:
    ComPort(Device *, QString);//контсруктор(родительское устройство, настройки)

    bool OpenPort();//открытие порта
    bool ClosePort() {}
};

#endif // COMPORT_H
